/*
 * putimg: writes a DOS file to a floppy in image mode
 *         occasionally useful for installing a better class
 *         of operating system
 *
 * Nigel Roles
 *         bugs/comments to ngr@symbionics.co.uk
 *
 * Compiles with Borland C 
 */

#include <stdio.h>
#include <dos.h>
#include <sys/stat.h>
#include <stdlib.h>

#define SPT (18 * 2)
#define BPS (512)
#define TPD (80)
#define BPD (TPD * SPT * (long)BPS)

void
usage(void)
{
	fprintf(stderr, "usage: putimg drive file\n");
	exit(1);
}

unsigned char buffer[SPT * BPS];

void
main(int argc, char *argv[])
{
	FILE *f;
	int drive;
	int track;
	struct stat sb;

	if (argc != 3)
		usage();
	switch (argv[1][0]) {
	case 'a':
	case 'A':
		drive = 0;
		break;
	case 'b':
	case 'B':
		drive = 1;
		break;
	default:
		fprintf(stderr, "drive must be A or B\n");
		exit(1);
	}
	f = fopen(argv[2], "rb");
	if (f == 0) {
		perror(argv[2]);
		exit(1);
	}
	if (fstat(fileno(f), &sb) != 0) {
		perror(argv[2]);
		exit(1);
	}
	if (sb.st_size != BPD) {
		fprintf(stderr, "%s: not %ld bytes in size\n", argv[2], BPD);
		exit(1);
	}
	for (track = 0; track < TPD; track++) {
		if (fread(buffer, SPT * BPS, 1, f) != 1) {
			perror(argv[2]);
			exit(1);
		}
		if (abswrite(drive, SPT, SPT * track, buffer) != 0) {
			fprintf(stderr, "drive %s: bios error 0x%.2x\n",
			    argv[1], errno >> 8);
			exit(1);
		}
	}
	exit(0);
}
